/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package util;
import org.jdom.Element;
public abstract class Rule {
	
	private String label;
	private int charge=0;
	
	public Rule(String label, int charge)
	{
		if (label==null)
			throw new NullPointerException("Null label");
		this.label=label;
		this.charge=charge;

	}
	
	public Rule(String label)
	{
		this(label,0);
	}

	public int getCharge() {
		return charge;
	}

	public String getLabel() {
		return label;
	}
	
	
	
	
	
	public abstract String toString();
	public abstract Element getElement();

	
	

}
