/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package util;
public class RuleReference {
	
	private Rule rule;
	private int countApplications=0;
	
	public RuleReference(Rule rule)
	{
		this.rule=rule;
	}
	
	
	public Rule getRule() {
		return rule;
	}
	
	public void incCountApplications()
	{
		incCountApplications(1);
	}
	
	public void decCountApplications()
	{
		decCountApplications(1);
	}
	public void incCountApplications(int number)
	{
		countApplications+=number;
	}
	public void decCountApplications(int number)
	{
		if (countApplications-number>=0)
			countApplications-=number;
	}

	public int getCountApplications() {
		return countApplications;
	}

	public String toString() {
		
		return countApplications + "*" + rule;
	}
	
	
	
	
	

}
/*
 * P-Lingua compiler 1.0 beta
 * 
 * Ignacio Perez-Hurtado
 * Research Group On Natural Computing
 * perezh@us.es
 * http://www.gcn.us.es
 * 
 * February, 2008
 */