/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am;

import java.util.Collection;

import util.Membrane;
import util.CellLikeMembrane;
import factory.Configuration;
import java.util.HashSet;

public class AmConfiguration extends Configuration {

	private CellLikeMembrane skinMembrane=null;
	
	public AmConfiguration(AmPsystem psystem)
	{
		super(psystem);
	}
	
	
	public CellLikeMembrane getSkinMembrane() {
		return skinMembrane;
	}


	public void setSkinMembrane(CellLikeMembrane skinMembrane) {
		this.skinMembrane = skinMembrane;
	}



	public Collection<? extends Membrane> getMembranes() {
		if (skinMembrane==null)
			return new HashSet<Membrane>();
		else
			return skinMembrane.getAllMembranes();
	}
	
	public Configuration clone()
	{
		AmConfiguration c = new AmConfiguration((AmPsystem)getPsystem());
		c.setSkinMembrane(getSkinMembrane().clone());
		c.setNumber(getNumber());
		c.getEnvironment().addAll(getEnvironment());
		return c;
	}

}
