/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am;

import factory.InputParser;
import factory.Psystem;
import variants.am.pLinguaInputParser.ParserInterface;
import variants.am.pLinguaInputParser.javaCC.PLinguaParser;
import variants.am.pLinguaInputParser.javaCC.ParseException;
import util.PlinguaCoreException;
import java.io.InputStream;
import java.io.StringReader;


public class AmPLinguaInputParser extends InputParser {


	
	
	@Override
	public Psystem parse(StringReader reader) throws PlinguaCoreException {
		Psystem psystem=null;
		try
		{
			ParserInterface.getInstance().setErrorChannel(getErrorChannel());
			ParserInterface.getInstance().setMsgChannel(getMsgChannel());
			ParserInterface.getInstance().setWarningChannel(getWarningChannel());
			ParserInterface.getInstance().setInfoChannel(getInfoChannel());
			ParserInterface.getInstance().setVerbosityLevel(getVerbosityLevel());
			
			PLinguaParser.parse(reader);
			if (!ParserInterface.getInstance().isError())
				psystem = ParserInterface.getInstance().getModel();
			
			
			
		}
		catch(ParseException ex)
		{
			throw new PlinguaCoreException(ex.getMessage()); 
		}
		return psystem;
		
		
	}

	public Psystem parse(InputStream stream) throws PlinguaCoreException{
		Psystem psystem=null;
		try
		{
			ParserInterface.getInstance().setErrorChannel(getErrorChannel());
			ParserInterface.getInstance().setMsgChannel(getMsgChannel());
			ParserInterface.getInstance().setWarningChannel(getWarningChannel());
			ParserInterface.getInstance().setInfoChannel(getInfoChannel());
			ParserInterface.getInstance().setVerbosityLevel(getVerbosityLevel());
			
			PLinguaParser.parse(stream);
			if (!ParserInterface.getInstance().isError())
				psystem = ParserInterface.getInstance().getModel();
			
		}
		catch(ParseException ex)
		{
			throw new PlinguaCoreException(ex.getMessage()); 
		}
		return psystem;
		
		
	}

}
