/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am;

import factory.OutputParser;


import java.io.OutputStream;
import java.io.PrintWriter;

import org.jdom.Document;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import java.io.Writer;



public class AmXMLOutputParser extends OutputParser {

	public AmXMLOutputParser(AmPsystem psystem)
	{
		super(psystem);
	}
	
	
	public boolean parse(OutputStream stream) {
		if (getPsystem()==null)
			return false;
		Document d=getPsystem().getDocument();
		if (d==null)
			return false;
		XMLOutputter x = new XMLOutputter(Format
				.getPrettyFormat());
		try {
			PrintWriter pw = new PrintWriter(stream);
			x.output(d, pw);
			return true;
		} catch (Exception e) {return false;}
			
		
	}
	public boolean parse(Writer writer) {
		if (getPsystem()==null)
			return false;
		Document d=getPsystem().getDocument();
		if (d==null)
			return false;
		XMLOutputter x = new XMLOutputter(Format
				.getPrettyFormat());
		try {
			x.output(d, writer);
			return true;
		} catch (Exception e) {return false;}
			
		
	}
}
