/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.gui;


import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import java.awt.BorderLayout;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Color;
import javax.swing.JList;
import java.awt.Component;
import javax.swing.ListSelectionModel;
import java.util.Iterator;







import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;




public class AlphabetPanel extends JPanel implements ActionListener, AmGuiView{
	
	
	public static final int TYPE_ALPHABET=0;
	public static final int TYPE_OBJECTS=20;
	public static final int TYPE_ENVIRONMENT=10;
	private Component owner = null;
	private AmGuiModel model=null;
	private static final long serialVersionUID = 1L;
	private JScrollPane jScrollPane = null;
	private JToolBar jToolBar = null;
	private JList jList = null;
	private String title=null;
    private int type=TYPE_ALPHABET;
	public AlphabetPanel(AmGuiModel model,Component owner,String title,int type) {
		super();
		this.model=model;
		this.owner = owner;
		this.title=title;
		this.type=type;
		initialize();
	}
	
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setLayout(new BorderLayout());
		
		
		this.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createLineBorder(Color.gray, 1),
				title,
				TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION,
				null,
				null));
		this.add(getJScrollPane(), BorderLayout.CENTER);
		this.add(getJToolBar(), BorderLayout.SOUTH);
		updateView();
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
			jScrollPane.setViewportView(getJList());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jToolBar	
	 * 	
	 * @return javax.swing.JToolBar	
	 */
	private JToolBar getJToolBar() {
		if (jToolBar == null) {
			jToolBar = new JToolBar();
			jToolBar.setFloatable(false);
		}
		return jToolBar;
	}

	/**
	 * This method initializes jList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJList() {
		if (jList == null) {
			jList = new JList();
			jList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
		}
		return jList;
	}
	
	

	public void updateView()
	{
		if (type==TYPE_ALPHABET)
			jList.setListData(model.getSimulator().getPsystem().getAlphabet().toArray());
		else
		if (type==TYPE_OBJECTS || type==TYPE_ENVIRONMENT)
		{
			Object []o;
			Iterator it;
			if (model.getSelectedMembrane()==null || type==TYPE_ENVIRONMENT)
			{
				o= new Object[model.getSimulator().getCurrentConfig().getEnvironment().entrySet().size()];
				 it=model.getSimulator().getCurrentConfig().getEnvironment().entrySet().iterator();
			}
			else
			{
				o= new Object[model.getSelectedMembrane().getMultiSet().entrySet().size()];
			    it=model.getSelectedMembrane().getMultiSet().entrySet().iterator();
			}
			int i=0;
			while(it.hasNext())
			{
				String str=it.next().toString();
				int c;
				if (model.getSelectedMembrane()!=null)
					c=model.getSelectedMembrane().getMultiSet().count(str);
				else
					c=model.getSimulator().getCurrentConfig().getEnvironment().count(str);
				if (c>1)
				str+="*"+c;
				o[i]=str;
				i++;
			}
			jList.setListData(o);
		}
		
		
			
			
		
		
	}

	
	
	
	public void actionPerformed(ActionEvent e)
	{
	  
	    
	}

	
}
