/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.gui;

import java.util.ArrayList;
import java.util.Collection;
import variants.am.AmSimulator;
import java.util.Iterator;
import util.CellLikeMembrane;

public class AmGuiModel {
	
	private Collection<AmGuiController> controllers;
	private AmSimulator simulator = null;
	private CellLikeMembrane selectedMembrane = null;
	
	public AmGuiModel(AmSimulator simulator)
	{
		controllers = new ArrayList<AmGuiController>();
		this.simulator=simulator;
	}
	
		
	
	public CellLikeMembrane getSelectedMembrane() {
		return selectedMembrane;
	}



	public void setSelectedMembrane(CellLikeMembrane selectedMembrane) {
		this.selectedMembrane = selectedMembrane;
	}



	public void addController(AmGuiController c)
	{
		controllers.add(c);
	}
	
	public void deleteController(AmGuiController c)
	{
		controllers.remove(c);
	}
	
	public void notifyControllers()
	{
		Iterator <AmGuiController> it;
		it = controllers.iterator();
		while(it.hasNext())
			it.next().updateView();
	}

	public AmSimulator getSimulator() {
		return simulator;
	}


	
	

}
