/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.gui;

import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultMutableTreeNode;


import util.CellLikeMembrane;

import java.util.Iterator;


public class MembraneTreeModel extends DefaultTreeModel {
	static final long serialVersionUID = 1;

	

	public MembraneTreeModel() {
		super(null, true);
		
		this.setRoot(makeMembraneNode(null));
		reload();
		
		
	}

	private DefaultMutableTreeNode makeMembraneNode(CellLikeMembrane membrane) {
		
		DefaultMutableTreeNode root = new DefaultMutableTreeNode(membrane, true);
		
		if (membrane != null) {
			
		
			Iterator<CellLikeMembrane>it=membrane.childMembranesIterator();
			while(it.hasNext())
			{
				CellLikeMembrane m= it.next();
				root.add(makeMembraneNode(m));
				
			}
			
		}
		return root;

	}

	public void updateTree(CellLikeMembrane membrane) {
		
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Environment", true);
		root.add(makeMembraneNode(membrane));
		this.setRoot(root);
	
		reload();
	
	}
	

}
