/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.pLinguaInputParser;
import util.Alphabet;

import java.util.LinkedList;

import variants.am.pLinguaInputParser.javaCC.ParseException;
import variants.am.pLinguaInputParser.javaCC.Token;
import variants.am.rules.AmRule;
import util.CellLikeMembrane;
import util.MultiSet;

public interface IParserInterface {
	
	public int getVariableValue(String name,Token token) throws ParseException;
	public boolean started();
	public Alphabet getAlphabet();
	public void setSkinMembrane(CellLikeMembrane skin,Token token);
	public void callModule(String moduleName,LinkedList paramValues,Token token,boolean interactive) throws ParseException;
	public void incDepthLevel();
	public void decDepthLevel();
	public void writeError(String error);
	public void writeWarning(String warning);
	public void addModule(String name,Token token,LinkedList parameters) throws ParseException;
	public void begin();
	public void addRule(AmRule rule,Token token);
	public void multiSetAsig(String label,MultiSet<String> ms,boolean inc);
	public void addAlphabetObject(String object);
	
}
