/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */

package variants.am.pLinguaInputParser;

import java.util.HashMap;
import java.util.LinkedList;




public class ModuleInstance {
	
	private Module module;
	private HashMap variables;
	
	
	public ModuleInstance(Module module,LinkedList paramValues)
	{
		this.module=module;
		variables = new HashMap();
		
			
		for (int i= 0;i<module.getParameters().size();i++)
		{
			if (i<paramValues.size())
				variables.put(module.getParameters().get(i),paramValues.get(i));
			else
				variables.put(module.getParameters().get(i),new Integer(0));
		}
	}

	public Module getModule() {
		return module;
	}
	
	public Integer getVariableValue(String variableName)
	{
		if (!variables.containsKey(variableName))
			return null;
		else
			return (Integer)variables.get(variableName);
	}
	
	public void setVariableValue(String variableName,int value)
	{
		variables.put(variableName,new Integer(value));
	}
	
	public boolean isDefined(String variableName)
	{
		return variables.containsKey(variableName);
	}
	
	
	
	
	
	

}
