/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.pLinguaInputParser;

import variants.am.pLinguaInputParser.javaCC.Token;

public class RangeIterator {
	
	private Token initialValue;
	private Token variable;
	private Token finalValue;
	private boolean b1;
	private boolean b2;
	
	public RangeIterator(Token initialValue,Token variable,Token finalValue,boolean b1,boolean b2)
	{
		this.initialValue=initialValue;
		this.variable=variable;
		this.finalValue=finalValue;
		this.b1=b1;
		this.b2=b2;
	}

	public Token getFinalValue() {
		return finalValue;
	}

	public Token getInitialValue() {
		return initialValue;
	}

	public Token getVariable() {
		return variable;
	}
	
	public boolean getB1()
	{
		return b1;
	}
	public boolean getB2()
	{
		return b2;
	}
	

}
