/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.pLinguaInputParser;
import variants.am.pLinguaInputParser.javaCC.PLinguaParser;
import variants.am.pLinguaInputParser.javaCC.ParseException;
import variants.am.pLinguaInputParser.javaCC.Token;

import java.util.LinkedList;

public class Sentence {
	private Token token;
	private LinkedList iterators;
	
	public Sentence(Token token)
	{
		this.token=token;
		iterators=new LinkedList();
	}
	
	public void addIterator(Token initialValue,Token variable,Token finalValue,boolean b1,boolean b2)
	{
		iterators.addFirst(new RangeIterator(initialValue,variable,finalValue,b1,b2));
	}
	
	public void doSentence() throws ParseException
	{
		if (!ParserInterface.getInstance().started())
			return;
		Token returnToken=PLinguaParser.token;
		doSentenceRec(ParserInterface.getInstance().getActualInstance(),0);
		PLinguaParser.token=returnToken;
		PLinguaParser.resetNtk();
		
			
	}
	
	private void doSentenceRec(ModuleInstance instance,int index) throws ParseException
	{
			if (index==iterators.size())
			{
				PLinguaParser.token=token;
				PLinguaParser.resetNtk();
				PLinguaParser.instruction();
			}
			else
			{
				RangeIterator it= (RangeIterator)iterators.get(index);
				PLinguaParser.token=it.getVariable();
				PLinguaParser.resetNtk();
				String var = PLinguaParser.id();
				PLinguaParser.token=it.getInitialValue();
				PLinguaParser.resetNtk();
				int min=PLinguaParser.integerValue();
				PLinguaParser.token=it.getFinalValue();
				PLinguaParser.resetNtk();
				int max=PLinguaParser.integerValue();
				if (it.getB1())
					min++;
				if (it.getB2())
					max--;
				for (int i=min;i<=max;i++)
				{
					instance.setVariableValue(var, i);
					doSentenceRec(instance,index+1);
				}
			}
	}

}
