/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.rules;

import util.Membrane;
import util.CellLikeMembrane;
import util.MultiSet;
import util.PlinguaCoreException;

public class AmSendInRule extends AmSendRule {
	
	public AmSendInRule(String label, int charge,String leftHandObject,int newCharge,String rightHandObject) 
	{
		super(label,charge,leftHandObject,newCharge,rightHandObject);
	}
	
	
	
	public String toString() {
		
		return  getRuleName()+": "+getLeftHandObject()+Membrane.getChargeSymbol(getCharge())+"[]'"+getLabel()+" --> "+Membrane.getChargeSymbol(getNewCharge())+"["+getRightHandObject()+"]";
	}

	
	
	public void executeRule(CellLikeMembrane m,int applications,MultiSet<String>environment) throws PlinguaCoreException {
	
		if (applications>1)
			throw new PlinguaCoreException();
		
		CellLikeMembrane p = m.getParentMembrane();
		p.getMultiSet().remove(getLeftHandObject());
		m.getMultiSet().add(getRightHandObject());
		m.getNewMultiSet().add(getRightHandObject());
		m.setCharge(getNewCharge());
		
	}



	@Override
	public int getRuleType() {
		return SEND_IN_RULE;
	}
	
	
	
	

}
