/*
 * This file is part of the pLinguaCore API 
 * pLinguaCore is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *  pLinguaCore is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with P-Lingua compiler.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  pLinguaCore 1.0 beta
 *  Copyright (c) Ignacio Perez-Hurtado 
 *  perezh@us.es
 *  Research Group On Natural Computing
 *  http://www.gcn.us.es
 */
package variants.am.rules;

import org.jdom.Attribute;
import org.jdom.Element;



public abstract class AmSendRule extends AmRule{
	
	private String rightHandObject;
	private int newCharge;
	
	public AmSendRule(String label,int charge,String leftHandObject,int newCharge,String rightHandObject) 
	{
		super(label,charge,leftHandObject);
		this.newCharge = newCharge;
		this.rightHandObject = rightHandObject;
	}

	public int getNewCharge() {
		return  newCharge;
	}
	
	public String getRightHandObject() {
		return rightHandObject;
	}

	public Element getElement() {
		Element e= super.getElement();
		Element e1=new Element("right_hand_rule");
		e1.setAttribute(new Attribute("object",rightHandObject));
		if (newCharge>0)
			e1.setAttribute(new Attribute("charge","+1"));
		else
		if (newCharge<0)
			e1.setAttribute(new Attribute("charge","-1"));
		else
			e1.setAttribute(new Attribute("charge","0"));
		e.addContent(e1);
	   
		return e;
	}	
	
	
	

}
